////////////////////////////////////////////////////////////////////////
// Boilerplate code for proxying arbitrary types via arbitrary
// proxy functors.
//**********************************************************************
// OBSOLETED BY reg_serializable_traits.hpp!!!
//**********************************************************************
// It is compatible with ALL types which can be proxied via an
// existing functor.
// License: Public Domain
// Author: stephan@s11n.net
////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////
// NOTE: this file does not use a conventional BLAH_H_INCLUDED guard.
// Yes, that's on purpose.
////////////////////////////////////////////////////////////////////////
// See reg_serializable_traits.hpp for the documentation.
////////////////////////////////////////////////////////////////////////
// General notes:
//
// By s11n convention S11N_NAME should contain no spaces, even for
// template types. Thus, please use:
//
//    "std::list<std::list<foo*>>"
//
// instead of:
//
//     "std::list<std::<list<foo *> >"
//
// C++ needs a space between "> >", but s11n does not.
// That said, s11n DOESN'T CARE what class names you use, as long
// as you're consistent.
//
////////////////////////////////////////////////////////////////////////

// #warning "reg_proxy.hpp is obelete. Please use reg_serializable_traits.hpp instead!"
#ifndef S11N_NAME // old convention
#  ifndef S11N_TYPE_NAME // new convention
#    error "S11N_TYPE_NAME must be set to the string form of S11N_TYPE"
#  else
#    define S11N_NAME S11N_TYPE_NAME
#  endif
#endif

#ifndef S11N_TYPE_NAME
#  define S11N_TYPE_NAME S11N_NAME
#endif

#ifndef S11N_SERIALIZE_FUNCTOR
#    error "S11N_SERIALIZE_FUNCTOR must be set to the name of a functor which will handle requests on behalf of S11N_TYPE."
#endif

#include <s11n.net/s11n/reg_serializable_traits.hpp>

#ifdef S11N_NAME
#  undef S11N_NAME
#endif
#undef S11N_SERIALIZER_TYPE
#undef S11N_DESERIALIZER_TYPE


